<template>
  <section>
    <section
      class="cards-wrapper"
      v-show="
            !this.ifEditUser &&
              (this.actualUserRole.role === 'admin' ||
                this.actualUserRole.role === 'vendedor' ||
                this.idSearchedUser === this.idActualUser)
          "
    >
      <div class="card" :style="{ backgroundImage: `url(${actualBackground})` }"></div>
      <div>
        <h1>{{ user.nickname }}</h1>
        <p>{{ user.penascales }} Pñ</p>
      </div>
      <v-btn v-on:click="edituser(user)" class="edit-user">editar</v-btn>
    </section>
    <section class="cards-wrapper">
      <img :src="this.localUser.image.dataUrl" v-if="this.ifEditUser && this.localUser.hasImage" />

      <image-uploader
        v-show="this.ifEditUser"
        :preview="false"
        :className="[
            'fileinput',
            { 'fileinput--loaded': localUser.hasImage }
          ]"
        capture="environment"
        :debug="1"
        doNotResize="gif"
        :autoRotate="true"
        outputFormat="verbose"
        @input="setImage"
      >
        <label for="fileInput" slot="upload-label">
          <figure>
            <svg xmlns="http://www.w3.org/2000/svg" width="32" height="32" viewBox="0 0 32 32">
              <path
                class="path1"
                d="M9.5 19c0 3.59 2.91 6.5 6.5 6.5s6.5-2.91 6.5-6.5-2.91-6.5-6.5-6.5-6.5 2.91-6.5 6.5zM30 8h-7c-0.5-2-1-4-3-4h-8c-2 0-2.5 2-3 4h-7c-1.1 0-2 0.9-2 2v18c0 1.1 0.9 2 2 2h28c1.1 0 2-0.9 2-2v-18c0-1.1-0.9-2-2-2zM16 27.875c-4.902 0-8.875-3.973-8.875-8.875s3.973-8.875 8.875-8.875c4.902 0 8.875 3.973 8.875 8.875s-3.973 8.875-8.875 8.875zM30 14h-4v-2h4v2z"
              />
            </svg>
          </figure>
          <span class="upload-caption">
            {{
            localUser.hasImage ? 'Replace' : 'Click to upload'
            }}
          </span>
        </label>
      </image-uploader>
      <div>
        <input
          type="text"
          v-model="localUser.nickname"
          v-show="this.ifEditUser"
          class="nickName-input"
        />
      </div>

      <div>
        <input
          type="text"
          v-model="localUser.penascales"
          v-show="this.ifEditUser && this.actualUserRole.role === 'admin'"
          class="panascales"
        />
      </div>
      <div>
        <select
          v-show="this.ifEditUser && this.actualUserRole.role === 'admin'"
          v-model="localUser.role"
          class="role-input"
        >
          <option v-for="(role, index) in roles" v-bind:key="index">
            <h1>{{ role.role }}</h1>
          </option>
        </select>
      </div>

      <v-btn v-show="this.ifEditUser" v-on:click="cancelUser(user)" class="cancel-edit">cancelar</v-btn>
      <v-btn
        v-show="this.ifEditUser"
        v-on:click="SaveChangedDetails()"
        class="SaveChangesButton"
      >guardar</v-btn>
    </section>
  </section>
</template>

<script>
import ImageUploader from 'vue-image-upload-resize'
import API from '@/API.js'
export default {
  name: 'UserProfile',
  components: {
    ImageUploader
  },
  props: {
    role: String
  },
  data() {
    return {
      actualBackground: '',
      oldImg: true,
      idActualUser: this.$route.params.idActualUser,
      actualUserRole: {},
      idSearchedUser: this.$route.params.id_user,
      actualUser: {},
      roles: null,
      ifEditUser: false,
      user: {},
      localUser: {},
      dateCreate: new Date().toLocaleString(),
      intervalId: null
    }
  },

  async mounted() {
    this.putUserEnData()
    this.putRolesEnData()
    this.actualUserRole = await API.getIdActualUser(this.idActualUser)
    if (
      this.actualUserRole.role !== 'admin' &&
      this.actualUserRole.role !== 'vendedor'
    ) {
      this.idSearchedUser = this.idActualUser
      this.putUserEnData()
    }
    this.actualBackground = this.user.urlphoto
    this.intervalId = setInterval(this.putUserEnData, 10000)
  },

  watch: {
    user: {
      immediate: true,
      handler: function() {
        this.localUser = JSON.parse(JSON.stringify(this.user))
      }
    }
  },

  methods: {
    edituser: function() {
      let idActualUser = this.idActualUser
      this.actualUser = API.loadUserDetails(idActualUser)

      this.ifEditUser = true
    },

    async SaveChangedDetails() {
      await this.saveNewUser()
      await this.putUserEnData()
      this.ifEditUser = false
      this.oldImg = true
    },

    setImage: function(output) {
      this.oldImg = false
      this.localUser.hasImage = true
      this.localUser.image = output
    },

    cancelUser: function() {
      this.localUser = this.user
      this.ifEditUser = false
      this.oldImg = true
    },

    async putRolesEnData() {
      this.roles = await API.loadUserRoles()
    },

    async putUserEnData() {
      let idSearchedUser = this.idSearchedUser
      this.user = await API.loadUserDetails(idSearchedUser)
      this.actualBackground = this.user.urlphoto
    },

    monitoringLocalPhoto() {
      console.log('estoy aqui')
      if (this.localUser.image === undefined) {
        this.localUser.image = this.user.urlphoto
      } else {
        this.localUser.image = this.localUser.image.dataUrl
      }
    },

    async saveNewUser() {
      this.monitoringLocalPhoto()
      let idSearchedUser = this.idSearchedUser
      let localUser = this.localUser

      await API.uploadUpdatedUser(idSearchedUser, localUser)
    }
  },
  beforeDestroy() {
    clearInterval(this.intervalId)
  }
}
</script>


<style scoped>
/* .user_details {
  display: flex;
  flex-direction: column;
  justify-content: space-around;
  margin-top: 20px;
}
.userInfo {
  margin-top: 14%;
}
.userProfileButton {
  margin-top: 14%;
}
.image {
  height: 50%;
  width: 50%;
}
img {
  height: 50%;
  width: 50%;
} */

@import url('https://fonts.googleapis.com/css?family=Heebo:400,700|Open+Sans:400,700');

:root {
  --color: #3c3163;
  --transition-time: 0.5s;
}

* {
  box-sizing: border-box;
}

body {
  margin: 0;
  min-height: 100vh;
  font-family: 'Open Sans';
  background: #fafafa;
}
.card {
  color: inherit;
}

.cards-wrapper {
  display: grid;
  justify-content: center;
  align-items: center;
  grid-template-columns: 1fr 1fr 1fr;
  grid-gap: 4rem;
  padding: 4rem;
  margin: 0 auto;
  width: max-content;
}

.card {
  font-family: 'Heebo';
  --bg-filter-opacity: 0.5;
  background-image: linear-gradient(
      rgba(0, 0, 0, var(--bg-filter-opacity)),
      rgba(0, 0, 0, var(--bg-filter-opacity))
    ),
    var(--backgroundImage);
  height: 20em;
  width: 15em;
  font-size: 1.5em;
  color: white;
  border-radius: 1em;
  padding: 1em;
  /*margin: 2em;*/
  display: flex;
  align-items: flex-end;
  background-size: cover;
  background-position: center;
  box-shadow: 0 0 5em -1em black;
  transition: all, var(--transition-time);
  position: relative;
  overflow: hidden;
  border: 10px solid #ccc;
  text-decoration: none;
}

.card:hover {
  transform: rotate(0);
}

.card h1 {
  margin: 0;
  font-size: 1.5em;
  line-height: 1.2em;
  letter-spacing: 5px;
}

.card p {
  font-size: 0.75em;
  font-family: 'Open Sans';
  margin-top: 0.5em;
  line-height: 2em;
  position: relative;
}
h1:first-letter {
  text-transform: uppercase;
}
p:first-letter {
  text-transform: uppercase;
}
.card .tags {
  display: flex;
}

.card .tag {
  font-size: 0.75em;
  background: rgba(255, 255, 255, 0.5);
  border-radius: 0.3rem;
  padding: 0 0.5em;
  margin-right: 0.5em;
  line-height: 1.5em;
  transition: all, var(--transition-time);
}

.card .date {
  position: absolute;
  top: 0;
  right: 0;
  font-size: 0.75em;
  padding: 1em;
  line-height: 1em;
  opacity: 0.8;
}

.card:before,
.card:after {
  content: '';
  transform: scale(0);
  transform-origin: top left;
  border-radius: 50%;
  position: absolute;
  left: -50%;
  top: -50%;
  z-index: -5;
  transition: all, var(--transition-time);
  transition-timing-function: ease-in-out;
}

.card:before {
  background: #ddd;
  width: 250%;
  height: 250%;
}

.card:after {
  background: white;
  width: 200%;
  height: 200%;
}

.card:hover {
  color: var(--color);
}

.card:hover:before,
.card:hover:after {
  transform: scale(1);
}

.card-grid-space .num {
  font-size: 3em;
  margin-bottom: 1.2rem;
  margin-left: 1rem;
}

/* MEDIA QUERIES */
@media screen and (max-width: 1285px) {
  .cards-wrapper {
    grid-template-columns: 1fr 1fr;
  }
}

@media screen and (max-width: 900px) {
  .cards-wrapper {
    grid-template-columns: 1fr;
  }
  .info {
    justify-content: center;
  }
  .card-grid-space .num {
    /margin-left: 0;
    /text-align: center;
  }
}

@media screen and (max-width: 500px) {
  .cards-wrapper {
    padding: 4rem 2rem;
  }
  .card {
    max-width: calc(100vw - 4rem);
  }
}

@media screen and (max-width: 450px) {
  .info {
    display: block;
    text-align: center;
  }
  .info h1 {
    margin: 0;
  }
}

.cards-wrapper {
  display: grid;
  justify-content: center;
  align-items: center;
  grid-template-columns: 1fr 1fr 1fr 1fr;
  grid-gap: 4rem;
  padding: 4rem;
  margin: 0 auto;
  width: max-content;
}

@media screen and (max-width: 1285px) {
  .cards-wrapper {
    grid-template-columns: 1fr 1fr;
  }
}
@media screen and (max-width: 900px) {
  .cards-wrapper {
    grid-template-columns: 1fr;
  }
  .info {
    justify-content: center;
  }
  .card-grid-space .num {
    /margin-left: 0;
    /text-align: center;
  }
}
@media screen and (max-width: 500px) {
  .cards-wrapper {
    padding: 4rem 2rem;
  }
  .card {
    max-width: calc(100vw - 4rem);
  }
}
</style>
